//+------------------------------------------------------------------+
//|                                             Up and Down Bars.mq4 |
//|                                     Copyright  2009, Pro4x.com. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Pro4x.com"
#property link      "tim@pro4x.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Lime//wick
#property indicator_color2 Gold//wick
#property indicator_color3 Lime//candle
#property indicator_color4 Gold//candle
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3

//---- input parameters
extern int		BarWidth			= 1,
					CandleWidth		= 3;

//---- buffers
double Bar1[],
		 Bar2[],
		 Candle1[],
		 Candle2[];
      
int init() {

//---- indicators
	IndicatorShortName("Up/Dn Bars");
	IndicatorBuffers(4);
	SetIndexBuffer(0,Bar1);
	SetIndexBuffer(1,Bar2);				
	SetIndexBuffer(2,Candle1);
	SetIndexBuffer(3,Candle2);
	SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth);

   return(0);
}

int deinit() {
   Comment("");
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{   
   int counted_bars=IndicatorCounted();
   //---- check for possible errors
   if (counted_bars < 0) return(-1);
   //---- the last counted bar will be recounted
   if (counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;

   for(int i=limit;i>0;i--)
   {
      Bar1[i] = EMPTY_VALUE;
      Bar2[i] = EMPTY_VALUE;
      Candle1[i] = EMPTY_VALUE;
      Candle2[i] = EMPTY_VALUE;

      //For an "up" bar, if the open is in the lower 33% of the bar and the close is in the upper 33% of the bar, 
      //it's painted as an up bar, vice-versa for "down" bars.
      double HL = High[i]-Low[i];
           
      if(HL>0)
      {
         double OneThird = HL*0.33;
         
         /*Comment("\n" + "HL: " + DoubleToStr(HL,Digits) + "\n" + 
                "OneThird: " + DoubleToStr(OneThird,Digits) + "\n" + 
                "Open[i]: " + DoubleToStr(Open[i],Digits) + "\n"  +
                "High[i]: " + DoubleToStr(High[i],Digits) + "\n"  +
                "Low[i]: " + DoubleToStr(Low[i],Digits) + "\n"  +
                "Close[i]: " + DoubleToStr(Close[i],Digits) + "\n"  +
                "Low[i]+OneThird: " + DoubleToStr(Low[i]+OneThird,Digits) + "\n" + 
                "High[i]-OneThird: " + DoubleToStr(High[i]-OneThird,Digits) );*/
         
         if(Open[i]<=Low[i]+OneThird && Close[i]>=High[i]-OneThird) 
            SetCandleColor(1,i);
         else if(Open[i]>=High[i]-OneThird && Close[i]<=Low[i]+OneThird) 
            SetCandleColor(2,i); 	   
       }
   }
   return(0);
}

//+------------------------------------------------------------------+
void SetCandleColor(int col, int i)
{
	double high,low,bodyHigh,bodyLow;


	{
		bodyHigh = MathMax(Open[i],Close[i]);
		bodyLow  = MathMin(Open[i],Close[i]);
		high		= High[i];
		low		= Low[i];
	}

	Bar1[i] = low;	Candle1[i] = bodyLow;
	Bar2[i] = low;	Candle2[i] = bodyLow;
	
	switch(col)
	{
		case 1: 	Bar1[i] = high;	Candle1[i] = bodyHigh;	break;
		case 2: 	Bar2[i] = high;	Candle2[i] = bodyHigh;	break;
	
	}
}

